//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com mladen"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  DimGray
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  LimeGreen
#property indicator_color5  PaleVioletRed
#property indicator_levelcolor DarkSlateGray
#property indicator_width1  1
#property indicator_width2  3
#property indicator_width3  3
#property indicator_minimum -100
#property indicator_maximum  100


extern int    AroonPeriod      = 25;
extern int    Filter           = 50;
extern string Alerts_Settings  = "Settings for alerts";
extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;


//
//
//
//
//

double osc[];
double osclu[];
double oscld[];
double oscau[];
double oscad[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,osc);
   SetIndexBuffer(1,osclu);
   SetIndexBuffer(2,oscld);
   SetIndexBuffer(3,oscau); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,108);
   SetIndexBuffer(4,oscad); SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,108);
   SetIndexBuffer(5,trend);
      SetLevelValue(0, Filter);
      SetLevelValue(1,-Filter);
   
   IndicatorShortName("Aroon oscillator ("+AroonPeriod+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      double AroonUp = 100.0*(AroonPeriod-iHighest(NULL,0,MODE_HIGH,AroonPeriod+1,i)+i)/AroonPeriod;
      double AroonDn = 100.0*(AroonPeriod- iLowest(NULL,0,MODE_LOW ,AroonPeriod+1,i)+i)/AroonPeriod;
         osc[i] = AroonUp-AroonDn;
         osclu[i] = EMPTY_VALUE;
         oscld[i] = EMPTY_VALUE;
         oscau[i] = EMPTY_VALUE;
         oscad[i] = EMPTY_VALUE;
         trend[i] = trend[i+1];
            if (osc[i] >  Filter)                     trend[i] =  1;
            if (osc[i] < -Filter)                     trend[i] = -1;
            if (osc[i] <  Filter && osc[i] > -Filter) trend[i] = 0;
            if (trend[i] == 1)
            {
               osclu[i] = osc[i]; if (trend[i]!=trend[i+1]) oscau[i] = osc[i];
            }
            if (trend[i] == -1)
            {
               oscld[i] = osc[i]; if (trend[i]!=trend[i+1]) oscad[i] = osc[i];
            }
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
            int forBar = 0;
      else      forBar = 1;
      
      //
      //
      //
      //
      //

      if (oscau[forBar]!= EMPTY_VALUE) doAlert("Arron oscillator trend chaned to UP");
      if (oscad[forBar]!= EMPTY_VALUE) doAlert("Arron oscillator trend chaned to DOWN");
   }      
   return(0);
}


//----------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Aroon oscillator - ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail("Arron oscillator",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}